//+------------------------------------------------------------------+
//|                                                         CCFp.mq4 |
//|                                              SemSemFX@rambler.ru |
//|              http://onix-trade.net/forum/index.php?showtopic=107 |
//+------------------------------------------------------------------+
#property copyright "SemSemFX@rambler.ru"
#property link      "http://onix-trade.net/forum/index.php?showtopic=107"
//----
string Indicator_Name = "CCFp:    ";
int Objs = 0;
//----
#property indicator_separate_window
#property indicator_buffers 8
//---- parameters
int MA_Method = 3;
int Price = 6;
int Fast = 3;
int Slow = 5;
#property indicator_color1 Olive
#property indicator_color2 Aqua
#property indicator_color3 Red
#property indicator_color4 Yellow
#property indicator_color5 DarkOrange
#property indicator_color6 Pink
#property indicator_color7 Lime
#property indicator_color8 Teal
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 2
#property indicator_width6 2
#property indicator_width7 2
#property indicator_width8 2
extern int Num_Bars = 500;

double arrUSD[];
double arrEUR[];
double arrGBP[];
double arrCHF[];
double arrJPY[];
double arrAUD[];
double arrCAD[];
double arrNZD[];
  string endfx;
  bool noendfx=true;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void InitGV(string Name, double Value)
{
   if (GlobalVariableCheck(Name)==false ||
       IsTesting()==true)
      GlobalVariableSet(Name, Value);
}

void SetGV(string Name, double Value)
{
   GlobalVariableSet(Name, Value);
}

double GetGV(string Name)
{
   if (GlobalVariableCheck(Name)==false)
   {
      Alert ("CCFp - Global Variable "+Name+" does not exist!!");
      return (0);
   }
   return (GlobalVariableGet(Name));
}

int init()
  {
   InitGV("CCFp-Changed-USD",0);
   InitGV("CCFp-Changed-EUR",0);
   InitGV("CCFp-Changed-GBP",0);
   InitGV("CCFp-Changed-CHF",0);
   InitGV("CCFp-Changed-JPY",0);
   InitGV("CCFp-Changed-AUD",0);
   InitGV("CCFp-Changed-CAD",0);
   InitGV("CCFp-Changed-NZD",0);

endfx = StringSubstr(Symbol(),6,StringLen(Symbol())-6);
if (StringLen(endfx)==0) noendfx=true;
if (StringLen(endfx)>0) 
   noendfx=false;
   
///---- indicators
   Indicator_Name = StringConcatenate(Indicator_Name, " USD");
   Indicator_Name = StringConcatenate(Indicator_Name, " EUR");
   Indicator_Name = StringConcatenate(Indicator_Name, " GBP");
   Indicator_Name = StringConcatenate(Indicator_Name, " CHF");
   Indicator_Name = StringConcatenate(Indicator_Name, " AUD");
   Indicator_Name = StringConcatenate(Indicator_Name, " CAD");
   Indicator_Name = StringConcatenate(Indicator_Name, " JPY");
   Indicator_Name = StringConcatenate(Indicator_Name, " NZD");
   IndicatorShortName(Indicator_Name);
   int cur = 10; 
   int st = 23; 
   
   int window = WindowFind(Indicator_Name);
   if (window!=-1)
   {
      sl("~", cur, indicator_color1);
      cur += st;
      sl("~", cur, indicator_color2);
      cur += st;
      sl("~", cur, indicator_color3);
      cur += st;
      sl("~", cur, indicator_color4);
      cur += st;
      sl("~", cur, indicator_color5);
      cur += st;
      sl("~", cur, indicator_color6);
      cur += st;
      sl("~", cur, indicator_color7);
      cur += st;
      sl("~", cur, indicator_color8);
      cur += st;
   }
//----
   SetIndexStyle(0, DRAW_LINE, DRAW_LINE);
   SetIndexBuffer(0, arrUSD);
   SetIndexLabel(0, "USD"); 
   SetIndexStyle(1, DRAW_LINE, DRAW_LINE);
   SetIndexBuffer(1, arrEUR);
   SetIndexLabel(1, "EUR"); 
   SetIndexStyle(2, DRAW_LINE, DRAW_LINE);
   SetIndexBuffer(2, arrGBP);
   SetIndexLabel(2, "GBP"); 
   SetIndexStyle(3, DRAW_LINE, DRAW_LINE);
   SetIndexBuffer(3, arrCHF);
   SetIndexLabel(3, "CHF"); 
   SetIndexStyle(6, DRAW_LINE, DRAW_LINE);
   SetIndexBuffer(6, arrJPY);
   SetIndexLabel(6, "JPY"); 
   SetIndexStyle(4, DRAW_LINE, DRAW_LINE);
   SetIndexBuffer(4, arrAUD);
   SetIndexLabel(4, "AUD"); 
   SetIndexStyle(5, DRAW_LINE, DRAW_LINE);
   SetIndexBuffer(5, arrCAD);
   SetIndexLabel(5, "CAD"); 
   SetIndexStyle(7, DRAW_LINE, DRAW_LINE);
   SetIndexBuffer(7, arrNZD);
   SetIndexLabel(7, "NZD"); 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   for(int i = 0; i < Objs; i++)
     {
       if(!ObjectDelete(Indicator_Name + i))
           Print("error: code #", GetLastError());
     }
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
  
    int limit;
   int counted_bars = IndicatorCounted();
   double OPEN, HIGH, LOW, CLOSE;

   if(counted_bars < 0) 
       return(-1);

   if(counted_bars > 0) 
       counted_bars -= 10;
   if (Num_Bars<=5)
      Num_Bars = Bars;
   limit = MathMin(Bars - counted_bars, Num_Bars);
   RefreshRates();
   for(int i = 0; i < limit; i++)
   {
      double EURUSD_Fast = ma(StringConcatenate("EURUSD",endfx), Fast, MA_Method, Price, i);
      double EURUSD_Slow = ma(StringConcatenate("EURUSD",endfx), Slow, MA_Method, Price, i);
      if(!EURUSD_Fast || !EURUSD_Slow)
         break;
      double GBPUSD_Fast = ma(StringConcatenate("GBPUSD",endfx), Fast, MA_Method, Price, i);
      double GBPUSD_Slow = ma(StringConcatenate("GBPUSD",endfx), Slow, MA_Method, Price, i);
      if(!GBPUSD_Fast || !GBPUSD_Slow)
         break;
      double AUDUSD_Fast = ma(StringConcatenate("AUDUSD",endfx), Fast, MA_Method, Price, i);
      double AUDUSD_Slow = ma(StringConcatenate("AUDUSD",endfx), Slow, MA_Method, Price, i);
      if(!AUDUSD_Fast || !AUDUSD_Slow)
         break;
      double NZDUSD_Fast = ma(StringConcatenate("NZDUSD",endfx), Fast, MA_Method, Price, i);
      double NZDUSD_Slow = ma(StringConcatenate("NZDUSD",endfx), Slow, MA_Method, Price, i);
      if(!NZDUSD_Fast || !NZDUSD_Slow)
         break;
      double USDCAD_Fast = ma(StringConcatenate("USDCAD",endfx), Fast, MA_Method, Price, i);
      double USDCAD_Slow = ma(StringConcatenate("USDCAD",endfx), Slow, MA_Method, Price, i);
      if(!USDCAD_Fast || !USDCAD_Slow)
         break;
      double USDCHF_Fast = ma(StringConcatenate("USDCHF",endfx), Fast, MA_Method, Price, i);
      double USDCHF_Slow = ma(StringConcatenate("USDCHF",endfx), Slow, MA_Method, Price, i);
      if(!USDCHF_Fast || !USDCHF_Slow)
         break;
      double USDJPY_Fast = ma(StringConcatenate("USDJPY",endfx), Fast, MA_Method, Price, i);
      double USDJPY_Slow = ma(StringConcatenate("USDJPY",endfx), Slow, MA_Method, Price, i);
      if(!USDJPY_Fast || !USDJPY_Slow)
         break;

      arrUSD[i] = 0;
      arrUSD[i] += EURUSD_Slow / EURUSD_Fast - 1;
      arrUSD[i] += GBPUSD_Slow / GBPUSD_Fast - 1;
      arrUSD[i] += AUDUSD_Slow / AUDUSD_Fast - 1;
      arrUSD[i] += NZDUSD_Slow / NZDUSD_Fast - 1;
      arrUSD[i] += USDCHF_Fast / USDCHF_Slow - 1;
      arrUSD[i] += USDCAD_Fast / USDCAD_Slow - 1;
      arrUSD[i] += USDJPY_Fast / USDJPY_Slow - 1;

      arrEUR[i] = 0;
      arrEUR[i] += EURUSD_Fast / EURUSD_Slow - 1;
      arrEUR[i] += (EURUSD_Fast / GBPUSD_Fast) / 
                   (EURUSD_Slow/GBPUSD_Slow) - 1;
      arrEUR[i] += (EURUSD_Fast / AUDUSD_Fast) / 
                   (EURUSD_Slow/AUDUSD_Slow) - 1;
      arrEUR[i] += (EURUSD_Fast / NZDUSD_Fast) / 
                   (EURUSD_Slow/NZDUSD_Slow) - 1;
      arrEUR[i] += (EURUSD_Fast*USDCHF_Fast) / 
                   (EURUSD_Slow*USDCHF_Slow) - 1;
      arrEUR[i] += (EURUSD_Fast*USDCAD_Fast) / 
                   (EURUSD_Slow*USDCAD_Slow) - 1;
      arrEUR[i] += (EURUSD_Fast*USDJPY_Fast) / 
                   (EURUSD_Slow*USDJPY_Slow) - 1;

      arrGBP[i] = 0;
      arrGBP[i] += GBPUSD_Fast / GBPUSD_Slow - 1;
      arrGBP[i] += (EURUSD_Slow / GBPUSD_Slow) / 
                   (EURUSD_Fast / GBPUSD_Fast) - 1;
      arrGBP[i] += (GBPUSD_Fast / AUDUSD_Fast) / 
                   (GBPUSD_Slow / AUDUSD_Slow) - 1;
      arrGBP[i] += (GBPUSD_Fast / NZDUSD_Fast) / 
                   (GBPUSD_Slow / NZDUSD_Slow) - 1;
      arrGBP[i] += (GBPUSD_Fast*USDCHF_Fast) / 
                   (GBPUSD_Slow*USDCHF_Slow) - 1;
      arrGBP[i] += (GBPUSD_Fast*USDCAD_Fast) / 
                   (GBPUSD_Slow*USDCAD_Slow) - 1;
      arrGBP[i] += (GBPUSD_Fast*USDJPY_Fast) / 
                   (GBPUSD_Slow*USDJPY_Slow) - 1;

      arrAUD[i] = 0;
      arrAUD[i] += AUDUSD_Fast / AUDUSD_Slow - 1;
      arrAUD[i] += (EURUSD_Slow / AUDUSD_Slow) / 
                   (EURUSD_Fast / AUDUSD_Fast) - 1;
      arrAUD[i] += (GBPUSD_Slow / AUDUSD_Slow) / 
                   (GBPUSD_Fast / AUDUSD_Fast) - 1;
      arrAUD[i] += (AUDUSD_Fast/NZDUSD_Fast) / 
                   (AUDUSD_Slow / NZDUSD_Slow) - 1;
      arrAUD[i] += (AUDUSD_Fast*USDCHF_Fast) / 
                   (AUDUSD_Slow*USDCHF_Slow) - 1;
      arrAUD[i] += (AUDUSD_Fast*USDCAD_Fast) / 
                   (AUDUSD_Slow*USDCAD_Slow) - 1;
      arrAUD[i] += (AUDUSD_Fast*USDJPY_Fast) / 
                   (AUDUSD_Slow*USDJPY_Slow) - 1;

      arrNZD[i] = 0;
      arrNZD[i] += NZDUSD_Fast / NZDUSD_Slow - 1;
      arrNZD[i] += (EURUSD_Slow / NZDUSD_Slow) / 
                   (EURUSD_Fast/NZDUSD_Fast) - 1;
      arrNZD[i] += (GBPUSD_Slow / NZDUSD_Slow) / 
                   (GBPUSD_Fast / NZDUSD_Fast) - 1;
      arrNZD[i] += (AUDUSD_Slow / NZDUSD_Slow) / 
                   (AUDUSD_Fast / NZDUSD_Fast) - 1;
      arrNZD[i] += (NZDUSD_Fast*USDCHF_Fast) / 
                   (NZDUSD_Slow*USDCHF_Slow) - 1;
      arrNZD[i] += (NZDUSD_Fast*USDCAD_Fast) / 
                   (NZDUSD_Slow*USDCAD_Slow) - 1;
      arrNZD[i] += (NZDUSD_Fast*USDJPY_Fast) / 
                   (NZDUSD_Slow*USDJPY_Slow) - 1;

      arrCAD[i] = 0;
      arrCAD[i] += USDCAD_Slow / USDCAD_Fast - 1;
      arrCAD[i] += (EURUSD_Slow*USDCAD_Slow) / 
                   (EURUSD_Fast*USDCAD_Fast) - 1;
      arrCAD[i] += (GBPUSD_Slow*USDCAD_Slow) / 
                   (GBPUSD_Fast*USDCAD_Fast) - 1;
      arrCAD[i] += (AUDUSD_Slow*USDCAD_Slow) / 
                   (AUDUSD_Fast*USDCAD_Fast) - 1;
      arrCAD[i] += (NZDUSD_Slow*USDCAD_Slow) / 
                   (NZDUSD_Fast*USDCAD_Fast) - 1;
      arrCAD[i] += (USDCHF_Fast / USDCAD_Fast) / 
                   (USDCHF_Slow / USDCAD_Slow) - 1;
      arrCAD[i] += (USDJPY_Fast / USDCAD_Fast) / 
                   (USDJPY_Slow / USDCAD_Slow) - 1;

      arrCHF[i] = 0;
      arrCHF[i] += USDCHF_Slow / USDCHF_Fast - 1;
      arrCHF[i] += (EURUSD_Slow*USDCHF_Slow) / 
                   (EURUSD_Fast*USDCHF_Fast) - 1;
      arrCHF[i] += (GBPUSD_Slow*USDCHF_Slow) / 
                   (GBPUSD_Fast*USDCHF_Fast) - 1;
      arrCHF[i] += (AUDUSD_Slow*USDCHF_Slow) / 
                   (AUDUSD_Fast*USDCHF_Fast) - 1;
      arrCHF[i] += (NZDUSD_Slow*USDCHF_Slow) / 
                   (NZDUSD_Fast*USDCHF_Fast) - 1;
      arrCHF[i] += (USDCHF_Slow / USDCAD_Slow) / 
                   (USDCHF_Fast / USDCAD_Fast) - 1;
      arrCHF[i] += (USDJPY_Fast / USDCHF_Fast) / 
                   (USDJPY_Slow / USDCHF_Slow) - 1;

      arrJPY[i] = 0;
      arrJPY[i] += USDJPY_Slow / USDJPY_Fast - 1;
      arrJPY[i] += (EURUSD_Slow*USDJPY_Slow) / 
                   (EURUSD_Fast*USDJPY_Fast) - 1;
      arrJPY[i] += (GBPUSD_Slow*USDJPY_Slow) / 
                   (GBPUSD_Fast*USDJPY_Fast) - 1;
      arrJPY[i] += (AUDUSD_Slow*USDJPY_Slow) / 
                   (AUDUSD_Fast*USDJPY_Fast) - 1;
      arrJPY[i] += (NZDUSD_Slow*USDJPY_Slow) / 
                   (NZDUSD_Fast*USDJPY_Fast) - 1;
      arrJPY[i] += (USDJPY_Slow/USDCAD_Slow) / 
                   (USDJPY_Fast/USDCAD_Fast) - 1;
      arrJPY[i] += (USDJPY_Slow/USDCHF_Slow) / 
                   (USDJPY_Fast/USDCHF_Fast) - 1;
      
      if (i==0)
      {
         DisplayLabel("USD", arrUSD[i], iTime(NULL,0,0)+4*Period()*60, indicator_color1);
         DisplayLabel("EUR", arrEUR[i], iTime(NULL,0,0)+4*Period()*60, indicator_color2);
         DisplayLabel("GBP", arrGBP[i], iTime(NULL,0,0)+4*Period()*60, indicator_color3);
         DisplayLabel("CHF", arrCHF[i], iTime(NULL,0,0)+4*Period()*60, indicator_color4);
         DisplayLabel("AUD", arrAUD[i], iTime(NULL,0,0)+4*Period()*60, indicator_color5);
         DisplayLabel("CAD", arrCAD[i], iTime(NULL,0,0)+4*Period()*60, indicator_color6);
         DisplayLabel("JPY", arrJPY[i], iTime(NULL,0,0)+4*Period()*60, indicator_color7);
         DisplayLabel("NZD", arrNZD[i], iTime(NULL,0,0)+4*Period()*60, indicator_color8);
      }
   }//end block for(int i=0; i<limit; i++)
   
   SetGV("CCFp-Changed-USD",(arrUSD[1]-arrUSD[2]));
   SetGV("CCFp-Changed-EUR",(arrEUR[1]-arrEUR[2]));
   SetGV("CCFp-Changed-GBP",(arrGBP[1]-arrGBP[2]));
   SetGV("CCFp-Changed-CHF",(arrCHF[1]-arrCHF[2]));
   SetGV("CCFp-Changed-JPY",(arrJPY[1]-arrJPY[2]));
   SetGV("CCFp-Changed-AUD",(arrAUD[1]-arrAUD[2]));
   SetGV("CCFp-Changed-CAD",(arrCAD[1]-arrCAD[2]));
   SetGV("CCFp-Changed-NZD",(arrNZD[1]-arrNZD[2]));

//----
   SetColour("USD Trend", indicator_color1);
   SetColour("EUR Trend", indicator_color2);
   SetColour("GBP Trend", indicator_color3);
   SetColour("CHF Trend", indicator_color4);
   SetColour("AUD Trend", indicator_color5);
   SetColour("CAD Trend", indicator_color6);
   SetColour("JPY Trend", indicator_color7);
   SetColour("NZD Trend", indicator_color8);

   RefreshRates();
   return(0);
  }
//+------------------------------------------------------------------+
//|  Subroutines                                                     |
//+------------------------------------------------------------------+

void SetColour(string Name, int Colour)
{
   int Window = WindowFind(Indicator_Name);
   if (ObjectFind(Name)==Window)
      ObjectSet(Name,OBJPROP_COLOR,Colour);
}

void DisplayLabel(string Name, double DisplayValue, int DisplayTime, int DisplayColor)
{
   int Window = WindowFind(Indicator_Name);
   if (ObjectFind(Name)!=Window)
   {
      ObjectCreate(Name,OBJ_TEXT,Window,DisplayTime,DisplayValue);
   }
   else
   {
      ObjectSet(Name,OBJPROP_TIME1,DisplayTime);
      ObjectSet(Name,OBJPROP_PRICE1,DisplayValue);
      ObjectSet(Name,OBJPROP_COLOR,DisplayColor);
   }
   ObjectSetText(Name,Name);
}

double ma(string sym, int per, int Mode, int Price, int i)
  {
   double res = 0;
   int k = 1;
   int ma_shift = 0;
   int tf = 0;
   switch(Period())
     {
       case 1:     res += iMA(sym, tf, per*k, ma_shift, Mode, Price, i); 
                   k += 5;
       case 5:     res += iMA(sym, tf, per*k, ma_shift, Mode, Price, i); 
                   k += 3;
       case 15:    res += iMA(sym, tf, per*k, ma_shift, Mode, Price, i); 
                   k += 2;
       case 30:    res += iMA(sym, tf, per*k, ma_shift, Mode, Price, i); 
                   k += 2;
       case 60:    res += iMA(sym, tf, per*k, ma_shift, Mode, Price, i); 
                   k += 4;
       case 240:   res += iMA(sym, tf, per*k, ma_shift, Mode, Price, i); 
                   k += 6;
       case 1440:  res += iMA(sym, tf, per*k, ma_shift, Mode, Price, i); 
                   k += 4;
       case 10080: res += iMA(sym, tf, per*k, ma_shift, Mode, Price, i); 
                   k +=4;
       case 43200: res += iMA(sym, tf, per*k, ma_shift, Mode, Price, i); 
     } 
   return(res);
  }       
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void sl(string sym, int y, color col)
  {
   int window = WindowFind(Indicator_Name);
   if (window!=-1)
   {
      string ID = Indicator_Name + Objs;
      Print("Window: ", window, ", ID:", ID);
      int tmp = 10 + y;
      Objs++;
      if(ObjectCreate(ID, OBJ_LABEL, window, 0, 0))
        {
          //ObjectSet(ID, OBJPROP_CORNER, 1);
          ObjectSet(ID, OBJPROP_XDISTANCE, y + 35);
          ObjectSet(ID, OBJPROP_YDISTANCE, 0);
          ObjectSetText(ID, sym, 18, "Arial Black", col);
        }
     }
  } 
//+------------------------------------------------------------------+


